#ifndef __DRONEDGE_H__
#define __DRONEDGE_H__

#include <open62541/server.h>
#include "mavsdk_wrapper.h"
#include "pubsub.h"

struct messageNode {
  char *message;
  struct messageNode *next;
};
typedef struct {
  struct messageNode *head;
  struct messageNode *tail;
} MessageQueue;

UA_Double latitude = 0;
UA_Double longitude = 0;
UA_Float altitude_abs = 0;
UA_Float altitude_rel = 0;
UA_String message = {
    .length = 0,
    .data = NULL,
};

VariableData droneVariableArray[] = {
    {
        .name = "latitude",
        .description = "Latitude",
        .value = &latitude,
        .type = UA_TYPES_DOUBLE,
        .builtInType = UA_NS0ID_DOUBLE,
        .getter.getDouble = mavsdk_getLatitude,
    },
    {
        .name = "longitude",
        .description = "Longitude",
        .value = &longitude,
        .type = UA_TYPES_DOUBLE,
        .builtInType = UA_NS0ID_DOUBLE,
        .getter.getDouble = mavsdk_getLongitude,
    },
    {
        .name = "altitude_abs",
        .description = "Absolute Altitude (AMSL)",
        .value = &altitude_abs,
        .type = UA_TYPES_FLOAT,
        .builtInType = UA_NS0ID_FLOAT,
        .getter.getFloat = mavsdk_getAltitude,
    },
    {
        .name = "altitude_rel",
        .description = "Relative Altitude",
        .value = &altitude_rel,
        .type = UA_TYPES_FLOAT,
        .builtInType = UA_NS0ID_FLOAT,
        .getter.getFloat = mavsdk_getAltitudeRel,
    },
    {
        .name = "message",
        .description = "Message to send to the other drones",
        .value = &message,
        .type = UA_TYPES_STRING,
        .builtInType = UA_NS0ID_STRING,
        .getter.getString = get_message
    },
};


#endif /* __DRONEDGE_H__ */
